VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ClsDIB"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private Declare Sub ZeroMemory Lib "kernel32" Alias "RtlZeroMemory" (lpDst As Any, ByVal Length As Long)

Private Declare Function GetObject Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function SetRect Lib "user32" (lpRect As RECT, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function FillRect Lib "user32" (ByVal hDC As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Private Declare Function OleTranslateColor Lib "olepro32" (ByVal OLE_COLOR As Long, ByVal hPalette As Long, ColorRef As Long) As Long
Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Private Declare Function CreateDIBSection Lib "gdi32" (ByVal hDC As Long, lpBitsInfo As BITMAPINFOHEADER, ByVal wUsage As Long, lpBits As Long, ByVal Handle As Long, ByVal dw As Long) As Long
Private Declare Function GetDIBits256 Lib "gdi32" Alias "GetDIBits" (ByVal aHDC As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, lpBits As Any, lpBI As BITMAPINFO256, ByVal wUsage As Long) As Long
'Private Declare Function GetDIBits Lib "gdi32" (ByVal aHDC As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, lpBits As Any, lpBI As BITMAPINFO, ByVal wUsage As Long) As Long


Private Type BITMAPFILEHEADER
    bfType      As Integer
    bfSize      As Long
    bfReserved1 As Integer
    bfReserved2 As Integer
    bfOffBits   As Long
End Type

Private Type BITMAPINFOHEADER
    biSize          As Long
    biWidth         As Long
    biHeight        As Long
    biPlanes        As Integer
    biBitCount      As Integer
    biCompression   As Long
    biSizeImage     As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed       As Long
    biClrImportant  As Long
End Type

Private Type BITMAP
    bmType       As Long
    bmWidth      As Long
    bmHeight     As Long
    bmWidthBytes As Long
    bmPlanes     As Integer
    bmBitsPixel  As Integer
    bmBits       As Long
End Type

Private Type BITMAPINFO
  bmiHeader As BITMAPINFOHEADER
  bmiColors As Long
End Type

Private Type BITMAPINFO256
  bmiHeader As BITMAPINFOHEADER
  bmiColors(255) As Long
End Type

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type


'-- Public Enums.:
Public Enum eBPPCts
    [01_bpp] = 1
    [04_bpp] = 4
    [08_bpp] = 8
    [16_bpp] = 16
    [24_bpp] = 24
    [32_bpp] = 32
End Enum

Private Const DIB_RGB_COLORS      As Long = 0

Private m_uBIH    As BITMAPINFOHEADER
Private m_hDC     As Long
Private m_hDIB    As Long
Private m_hOldDIB As Long
Private m_lpBits  As Long
Private m_Bpp     As Long

Public Sub Fill(Optional ByVal Color As OLE_COLOR = vbBlack)
  
    Dim Rec  As RECT
    Dim hBrush As Long
   
    If (m_hDIB <> 0) Then
        Call SetRect(Rec, 0, 0, m_uBIH.biWidth, m_uBIH.biHeight)
        Call OleTranslateColor(Color, 0, Color)
        hBrush = CreateSolidBrush(Color)
        Call FillRect(m_hDC, Rec, hBrush)
        Call DeleteObject(hBrush)
    End If
End Sub



Function SaveToFile(ByVal fName As String, Optional ByVal Bpp As eBPPCts = [32_bpp]) As Long
    On Error GoTo ErrHandler
    
    Dim bmp As BITMAP
    Dim i As Integer
    Dim bInfo As BITMAPINFO256
    Dim FileHeader As BITMAPFILEHEADER
    Dim bArray() As Byte
    Dim nLines As Long
    Dim WidthArray As Long
    Dim fno As Long
    Dim Palette() As Long
    Dim PaletteSize As Long
    Dim newP As Long
    Dim nCol As Long
    
    Call GetObject(m_hDIB, Len(bmp), bmp)
    
    With bInfo
        .bmiHeader.biHeight = bmp.bmHeight
        .bmiHeader.biWidth = bmp.bmWidth
        .bmiHeader.biPlanes = bmp.bmPlanes
        .bmiHeader.biBitCount = Bpp
        .bmiHeader.biSize = Len(.bmiHeader)
        .bmiHeader.biCompression = 0
    End With
    
    nLines = GetDIBits256(m_hDC, m_hDIB, 0, bmp.bmHeight, ByVal 0, bInfo, DIB_RGB_COLORS)
    
    WidthArray = bInfo.bmiHeader.biSizeImage / bInfo.bmiHeader.biHeight
    ReDim bArray(1 To WidthArray, 1 To bInfo.bmiHeader.biHeight)

    nLines = GetDIBits256(m_hDC, m_hDIB, 0, bmp.bmHeight, bArray(1, 1), bInfo, DIB_RGB_COLORS)
                 
    Select Case Bpp

    Case 1
        bInfo.bmiHeader.biClrUsed = 2
        bInfo.bmiHeader.biClrImportant = 2
        nCol = 1
    Case 4
        bInfo.bmiHeader.biClrUsed = 16
        bInfo.bmiHeader.biClrImportant = 16
        nCol = 15
    Case 8
        bInfo.bmiHeader.biClrUsed = 256
        bInfo.bmiHeader.biClrImportant = 256
        nCol = 255
    Case 16, 24, 32
        nCol = 0
    End Select
    
    ReDim Palette(nCol)

    If nCol > 0 Then
        For i = 0 To nCol
            Palette(i) = bInfo.bmiColors(i)
        Next i
        PaletteSize = (UBound(Palette) + 1) * 4
    Else
        Palette(0) = 0
    End If
    
    
    
    
    FileHeader.bfType = 19778 '"BM"
    FileHeader.bfSize = Len(FileHeader) + Len(bInfo.bmiHeader) + bInfo.bmiHeader.biSizeImage + PaletteSize
    FileHeader.bfOffBits = Len(FileHeader) + Len(bInfo.bmiHeader) + PaletteSize
    fno = FreeFile
    Open fName$ For Binary As #fno

    Put #fno, , FileHeader
    Put #fno, , bInfo.bmiHeader
    If PaletteSize Then Put #fno, , Palette()
    Put #fno, , bArray()
    Close #fno
    SaveToFile = FileLen(fName$)
    
    Exit Function
ErrHandler:
    Close #fno
    MsgBox "Error: " & Err.Number & vbCrLf & Err.Description, vbCritical
End Function


Public Function Create(ByVal Width As Long, ByVal Height As Long, Optional ByVal Colors As eBPPCts = [32_bpp]) As Long
    
 
    Call Me.Destroy
    

    With m_uBIH
        .biSize = Len(m_uBIH)
        .biPlanes = 1
        .biBitCount = Colors
        .biWidth = Width
        .biHeight = Height
        .biSizeImage = ByteAlignOnWord(.biBitCount, .biWidth)
    End With
    
    m_Bpp = Colors
    m_hDC = CreateCompatibleDC(0)
    If (m_hDC <> 0) Then
        m_hDIB = CreateDIBSection(m_hDC, m_uBIH, DIB_RGB_COLORS, m_lpBits, 0, 0)
        If (m_hDIB <> 0) Then
            m_hOldDIB = SelectObject(m_hDC, m_hDIB)
          Else
            Call Me.Destroy
        End If
    End If

    Create = m_hDIB


End Function

Public Sub RestoreDC()
 Call SelectObject(m_hDC, m_hOldDIB)
End Sub

Public Sub Destroy()


    If (m_hDC <> 0) Then
        If (m_hDIB <> 0) Then
            Call SelectObject(m_hDC, m_hOldDIB)
            Call DeleteObject(m_hDIB)
        End If
        Call DeleteDC(m_hDC)
    End If
    

    Call ZeroMemory(m_uBIH, Len(m_uBIH))
    
    m_hDC = 0
    m_hDIB = 0
    m_hOldDIB = 0
    m_lpBits = 0
End Sub


Private Function ByteAlignOnWord(ByVal bitDepth As Long, ByVal Width As Long) As Long
    ' function to align any bit depth on dWord boundaries
    ByteAlignOnWord = (((Width * bitDepth) + &H1F&) And Not &H1F&) \ &H8&
End Function


Public Property Get hDC() As Long
    hDC = m_hDC
End Property

Public Property Get hDib() As Long
    hDib = m_hDIB
End Property

Public Property Get lpBits() As Long
    lpBits = m_lpBits
End Property

Public Property Get Width() As Long
    Width = m_uBIH.biWidth
End Property

Public Property Get Height() As Long
    Height = m_uBIH.biHeight
End Property

Private Sub Class_Terminate()
    Me.Destroy
End Sub

