Attribute VB_Name = "MdlGDI"
Option Explicit

Private Declare Function GdipCreateHICONFromBitmap Lib "gdiplus" (ByVal BITMAP As Long, hbmReturn As Long) As Long
Private Declare Function GdiplusStartup Lib "gdiplus" (Token As Long, inputbuf As GdiplusStartupInput, Optional ByVal outputbuf As Long = 0) As Long
Private Declare Function GdipLoadImageFromFile Lib "gdiplus.dll" (ByVal mFilename As Long, ByRef mImage As Long) As Long
Private Declare Function GdipDeleteGraphics Lib "gdiplus.dll" (ByVal mGraphics As Long) As Long
Private Declare Function GdipDrawImage Lib "gdiplus.dll" (ByVal mGraphics As Long, ByVal mImage As Long, ByVal mX As Single, ByVal mY As Single) As Long
Private Declare Function GdipDisposeImage Lib "gdiplus" (ByVal Image As Long) As Long
Private Declare Function GdipGetImageGraphicsContext Lib "gdiplus" (ByVal Image As Long, hGraphics As Long) As Long
Private Declare Function GdipGetImageBounds Lib "gdiplus.dll" (ByVal mImage As Long, ByRef mSrcRect As RECTF, ByRef mSrcUnit As Long) As Long
Private Declare Function GdipDrawImageRect Lib "gdiplus.dll" (ByVal mGraphics As Long, ByVal mImage As Long, ByVal mX As Single, ByVal mY As Single, ByVal mWidth As Single, ByVal mHeight As Single) As Long
Private Declare Function GdipCreateBitmapFromScan0 Lib "gdiplus" (ByVal Width As Long, ByVal Height As Long, ByVal stride As Long, ByVal Format As Long, ByRef scan0 As Any, ByRef BITMAP As Long) As Long
Private Declare Function GdipImageRotateFlip Lib "gdiplus" (ByVal Image As Long, ByVal rfType As Long) As Long
Private Declare Function GdipCreateBitmapFromHBITMAP Lib "gdiplus.dll" (ByVal mHbm As Long, ByVal mhPal As Long, ByRef mBitmap As Long) As Long
Private Declare Function GdipSetInterpolationMode Lib "gdiplus" (ByVal graphics As Long, ByVal InterpolationMode As InterpolationMode) As Long
Private Declare Sub GdiplusShutdown Lib "gdiplus" (ByVal Token As Long)

Private Declare Function LoadImage Lib "user32" Alias "LoadImageA" (ByVal hInst As Long, ByVal lpsz As String, ByVal dwImageType As Long, ByVal dwDesiredWidth As Long, ByVal dwDesiredHeight As Long, ByVal dwFlags As Long) As Long
Private Declare Function GetDIBits Lib "gdi32.dll" (ByVal aHDC As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, ByRef lpBits As Any, ByRef lpBI As Any, ByVal wUsage As Long) As Long
Private Declare Function GetDC Lib "user32.dll" (ByVal hwnd As Long) As Long
Private Declare Function ReleaseDC Lib "user32.dll" (ByVal hwnd As Long, ByVal hdc As Long) As Long
Private Declare Function DeleteObject Lib "gdi32.dll" (ByVal hObject As Long) As Long
Private Declare Function StretchDIBits Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal dX As Long, ByVal dY As Long, ByVal srcX As Long, ByVal srcY As Long, ByVal wSrcWidth As Long, ByVal wSrcHeight As Long, lpBits As Any, lpBitsInfo As Any, ByVal wUsage As Long, ByVal dwRop As Long) As Long
Private Declare Function GetIconInfo Lib "user32.dll" (ByVal hIcon As Long, ByRef piconinfo As ICONINFO) As Long
Private Declare Function DestroyIcon Lib "user32.dll" (ByVal hIcon As Long) As Long

Private Declare Function GdipCreateBitmapFromHICON Lib "gdiplus.dll" (ByVal mHicon As Long, ByRef mBitmap As Long) As Long
Private Declare Function GdipCreateFromHDC Lib "gdiplus" (ByVal hdc As Long, ByRef graphics As Long) As Long
Private Declare Function CreateIconFromResourceEx Lib "user32.dll" (ByRef presbits As Any, ByVal dwResSize As Long, ByVal fIcon As Long, ByVal dwVer As Long, ByVal cxDesired As Long, ByVal cyDesired As Long, ByVal Flags As Long) As Long


Private Type BITMAP
    bmType As Long
    bmWidth As Long
    bmHeight As Long
    bmWidthBytes As Long
    bmPlanes As Integer
    bmBitsPixel As Integer
    bmBits As Long
End Type



Private Type BITMAPINFOHEADER
    biSize          As Long
    biWidth         As Long
    biHeight        As Long
    biPlanes        As Integer
    biBitCount      As Integer
    biCompression   As Long
    biSizeImage     As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed       As Long
    biClrImportant  As Long
End Type

Private Type ICONDIRENTRY
   bWidth               As Byte                 '// Width of the image
   bHeight              As Byte                 '// Height of the image (times 2)
   bColorCount          As Byte                 '// Number of colors in image (0 if >=8bpp)
   bReserved            As Byte                 '// Reserved
   wPlanes              As Integer              '// Color Planes
   wBitCount            As Integer              '// Bits per pixel
   dwBytesInRes         As Long                 '// how many bytes in this resource?
   dwImageOffset        As Long                 '// where in the file is this image
End Type

Private Type RGBQUAD
   rgbBlue As Byte
   rgbGreen As Byte
   rgbRed As Byte
   rgbReserved As Byte
End Type

Private Type BITMAPINFO
    bmiHeader As BITMAPINFOHEADER
    bmiPalette(0 To 255) As Long
End Type

Private Type BITMAPINFO_1BPP
   bmiHeader As BITMAPINFOHEADER
   bmiColors(0 To 1) As RGBQUAD
End Type

Private Const LR_LOADFROMFILE       As Long = &H10
Private Const IMAGE_BITMAP          As Long = 0

Private Type RECTF
    Left        As Single
    Top         As Single
    Width       As Single
    Height      As Single
End Type

Private Type GdiplusStartupInput
    GdiplusVersion           As Long
    DebugEventCallback       As Long
    SuppressBackgroundThread As Long
    SuppressExternalCodecs   As Long
End Type

Private Enum InterpolationMode
    InterpolationModeInvalid = &HFFFFFFFF
    InterpolationModeDefault = &H0
    InterpolationModeLowQuality = &H1
    InterpolationModeHighQuality = &H2
    InterpolationModeBilinear = &H3
    InterpolationModeBicubic = &H4
    InterpolationModeNearestNeighbor = &H5
    InterpolationModeHighQualityBilinear = &H6
    InterpolationModeHighQualityBicubic = &H7
End Enum

Private Type ICONINFO
    fIcon As Long
    xHotspot As Long
    yHotspot As Long
    hbmMask As Long
    hbmColor As Long
End Type

Private Type BuferColor
    Color As Long
    Count As Long
End Type

Private Const DIB_RGB_COLORS As Long = 0
Private Const IMAGE_ICON = 1

Private Const PixelFormat32bppARGB  As Long = &H26200A
Private Const PixelFormat32bppPARGB As Long = &HE200B
Private Const UnitPixel             As Long = &H2&


Public Function GetMaskColor(ByVal hBitmap As Long, ByVal lWidth As Long, ByVal lHeight As Long, NumIcon As Long) As Long
    Dim i As Long, j As Long, X As Long

    Dim aColors() As Long
    Dim BC() As BuferColor
    Dim bFind As Boolean
    Dim lMax As Long, arrSize As Long
    Dim hdc As Long, OldBMP As Long
        
    arrSize = (NumIcon * 4) - 1
    
    ReDim aColors(arrSize)
    
    hdc = CreateCompatibleDC(0)
    OldBMP = SelectObject(hdc, hBitmap)
    
    For i = 0 To NumIcon - 1
        aColors(j) = GetPixel(hdc, X, 0)
        aColors(j + 1) = GetPixel(hdc, X + lWidth - 1, 0)
        aColors(j + 2) = GetPixel(hdc, X, lHeight - 1)
        aColors(j + 3) = GetPixel(hdc, X + lWidth - 1, lHeight - 1)
        j = j + 4
        X = X + lWidth
    Next
    
    Call SelectObject(hdc, OldBMP)
    DeleteDC hdc
    
    ReDim BC(arrSize)
    X = 0
    
    For i = 0 To arrSize
       bFind = False
       For j = 0 To X
            If BC(j).Color = aColors(i) Then
                BC(j).Count = BC(j).Count + 1
                bFind = True
                Exit For
            End If
       Next
       If Not bFind Then BC(X).Color = aColors(i): X = X + 1
    Next

    For i = 0 To X - 1
        If BC(i).Count > lMax Then
            lMax = BC(i).Count
            GetMaskColor = BC(i).Color
        End If
    Next

End Function

